local BM_AMMO_ID = "bmammo_";
function BM_Ammo_OnLoad()	
	this:RegisterEvent("VARIABLES_LOADED");
	PLUG_IN_FRAME = "BM_Ammo";
	PLUG_IN_NAME = "BiB Ammo";
	BM_ICON_SIZE = BIB_AMMO_ICON_SIZE;
	BM_Plugin(PLUG_IN_FRAME, PLUG_IN_NAME, BM_ICON_SIZE, BM_AMMO_ID);
end

function BM_Ammo_OnEvent(event)	
	if (event == "VARIABLES_LOADED") then
		this:RegisterEvent("UNIT_MODEL_CHANGED");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");
		BM_Ammo_initialize();
		BM_Ammo_OnShow();
	end

	if (event == "PLAYER_ENTERING_WORLD") then
		this:RegisterEvent("BAG_UPDATE");
		this:RegisterEvent("ITEM_LOCK_CHANGED");
		this:RegisterEvent("PLAYER_LEAVING_WORLD");
	end

	if (event == "PLAYER_LEAVING_WORLD") then
		this:UnregisterEvent("BAG_UPDATE");
		this:UnregisterEvent("ITEM_LOCK_CHANGED");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");
	end

	BM_Ammo_Refresh();
end

function BM_Ammo_initialize()
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmammo_ShowIcon == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmammo_ShowIcon = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmammo_ShowLabelText == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmammo_ShowLabelText = true;
	end
end

function BM_Ammo_Refresh()
	local ammoSlotID = GetInventorySlotInfo("ammoSlot");
	local rangedSlotID = GetInventorySlotInfo("rangedSlot");
	local isThrown, isAmmo;
	local bag_text = "";
	local ammoText = "";
	local labelText = "";
	
	if (GetInventoryItemQuality("player", rangedSlotID) and
		string.find(GetInventoryItemLink("player", rangedSlotID), BAG_STATUS_KEYWORD)) then
		isThrown = 1;
	end
	if (not isThrown and GetInventoryItemQuality("player", ammoSlotID)) then
		isAmmo = 1;
	end
	if (isThrown) then
		count = GetInventoryItemCount("player", rangedSlotID);
		labelText = BAG_STATUS_LABEL_THROWN;
		if (count >= 100 and count <= 200) then
			ammoText = format(BAG_STATUS_FORMAT_GREEN, count);
		elseif (count >= 50 and count < 100) then
			ammoText = format(BAG_STATUS_FORMAT_YELLOW, count);
		else
			ammoText = format(BAG_STATUS_FORMAT_RED, count);
		end
		
	elseif (isAmmo) then
		count = GetInventoryItemCount("player", ammoSlotID);
		labelText = BAG_STATUS_LABEL_AMMO;
		if (count >= 400) then
			ammoText = format(BAG_STATUS_FORMAT_GREEN, count);
		elseif (count >= 150 and count < 400) then
			ammoText = format(BAG_STATUS_FORMAT_YELLOW, count);
		else
			ammoText = format(BAG_STATUS_FORMAT_RED, count);
		end
	else
		count = 0;
		labelText = BAG_STATUS_LABEL_AMMO_THROWN;
		ammoText = format(BAG_STATUS_FORMAT_WHITE, count);
	end
	

	if (TitanGetVar(BM_AMMO_ID, "ShowLabelText")) then
		BM_AmmoText:SetText(labelText .. ammoText);
	else
		BM_AmmoText:SetText(ammoText);
	end
end

function BM_Ammo_OnShow()
	BM_Ammo_SetIcon();
end

function BM_Ammo_SetIcon()
	local icon = BM_AmmoIcon;
	if (TitanGetVar(BM_AMMO_ID, "ShowIcon")) then
		icon:SetTexture(BM_IMAGE_PATH .. "Icon_ammo");
		icon:SetWidth(BIB_AMMO_ICON_SIZE);
		icon:SetHeight(BIB_AMMO_ICON_SIZE);
	else
		icon:SetTexture("");
		icon:SetWidth(1);
	end
end


---**** Options ****---
local BMAmmo_CheckButtons = { };
local ctext1 = BM_SHOW_ICON;
local ctext2 = BM_SHOW_LABEL;
BMAmmo_CheckButtons[ctext1] = {
	id = 1,
	strVar = "bmammo_ShowIcon",
	pSlashCommand = "BMAmmo_Check1_Opt"
};
BMAmmo_CheckButtons[ctext2] = {
	id = 2,
	strVar = "bmammo_ShowLabelText",
	pSlashCommand = "BMAmmo_Check2_Opt"
};

function BMAmmo_Check1_Opt(msg)
	TitanSetVar(BM_AMMO_ID, "ShowIcon", msg);
	BM_Ammo_SetIcon();
	BM_Ammo_Refresh();
end

function BMAmmo_Check2_Opt(msg)
	TitanSetVar(BM_AMMO_ID, "ShowLabelText", msg);
	BM_Ammo_Refresh();	
end

function BM_Ammo_RefreshOptions()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	for key, value in BMAmmo_CheckButtons do
		button = getglobal("BMAmmo_Check" .. value.id);
		string = getglobal("BMAmmo_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = getglobal(value.pSlashCommand);
	end
end